#!/usr/bin/env perl
use strict;
use warnings;
use utf8;
use FindBin::libs;

use Perl6::Say;
use Text::MeCab;
use Classifier;

my $cl = Classifier->new;
$cl->train(text2vec('perlやpythonはスクリプト言語です'), 'it');
$cl->train(text2vec('perlでベイジアンフィルタを作りました'), 'it');
$cl->train(text2vec('pythonはニシキヘビ科のヘビの総称'), 'science');

say sprintf "1. 推定カテゴリ: %s", $cl->predict(text2vec('perlは楽しい'));
say sprintf "2. 推定カテゴリ: %s", $cl->predict(text2vec('pythonとperl'));
say sprintf "3. 推定カテゴリ: %s", $cl->predict(text2vec('pythonはヘビ'));

sub text2vec {
    my $text = shift;
    my $vec = {};
    my $mecab = Text::MeCab->new;
    for (my $node = $mecab->parse($text); $node; $node = $node->next) {
        if ($node->posid =~ m/^(?:1|2|3|4)$/) {
            $vec->{$node->surface}++;
        }
    }
    return $vec;
}
